#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private TWSTHACO[] cacheTWSTHACO;
		private TWST123DonchianChannel[] cacheTWST123DonchianChannel;
		private TWSTFibsFromPriorDay[] cacheTWSTFibsFromPriorDay;
		private TWSTFibsFromCurrentDay[] cacheTWSTFibsFromCurrentDay;
		private TWST_HighLow_AreaSuperTrend[] cacheTWST_HighLow_AreaSuperTrend;
		private TWSTStochastic[] cacheTWSTStochastic;
		private TWSTOpeningRange[] cacheTWSTOpeningRange;
		private TWSTsuperTrend[] cacheTWSTsuperTrend;
		private TWSTfilterLine[] cacheTWSTfilterLine;
		private TWSTtrendLiner[] cacheTWSTtrendLiner;
		private TwstEMA[] cacheTwstEMA;
		private TWSTmarketProfile[] cacheTWSTmarketProfile;
		private EMASlopeColor[] cacheEMASlopeColor;

		
		public TWSTHACO TWSTHACO(int avg, int avgDn, int backgroundOpacity)
		{
			return TWSTHACO(Input, avg, avgDn, backgroundOpacity);
		}

		public TWST123DonchianChannel TWST123DonchianChannel(mamaDonchianInput selectedInput, int period, mamaDonchianTrendMode trendMode, double multiplierFast, double multiplierSlow)
		{
			return TWST123DonchianChannel(Input, selectedInput, period, trendMode, multiplierFast, multiplierSlow);
		}

		public TWSTFibsFromPriorDay TWSTFibsFromPriorDay(TWSTSessionTypeFPD sessionType, TWSTCalcModeFPD calcMode, double fibRetracementRatio1, double fibRetracementRatio2, double fibRetracementRatio3, double fibRetracementRatio4, double fibRetracementRatio5, double fibExpansionRatio1, double fibExpansionRatio2, double fibExpansionRatio3, double fibExpansionRatio4, double fibExpansionRatio5)
		{
			return TWSTFibsFromPriorDay(Input, sessionType, calcMode, fibRetracementRatio1, fibRetracementRatio2, fibRetracementRatio3, fibRetracementRatio4, fibRetracementRatio5, fibExpansionRatio1, fibExpansionRatio2, fibExpansionRatio3, fibExpansionRatio4, fibExpansionRatio5);
		}

		public TWSTFibsFromCurrentDay TWSTFibsFromCurrentDay(TWSTCalcModeFCD calcMode, double fibRetracementRatio1, double fibRetracementRatio2, double fibRetracementRatio3, double fibRetracementRatio4, double fibRetracementRatio5, double fibRetracementRatio6, double fibRetracementRatio7)
		{
			return TWSTFibsFromCurrentDay(Input, calcMode, fibRetracementRatio1, fibRetracementRatio2, fibRetracementRatio3, fibRetracementRatio4, fibRetracementRatio5, fibRetracementRatio6, fibRetracementRatio7);
		}

		public TWST_HighLow_AreaSuperTrend TWST_HighLow_AreaSuperTrend(int tenkanPeriod, int kijunPeriod, int senkouBPeriod, int senkouShift, int chikouShift)
		{
			return TWST_HighLow_AreaSuperTrend(Input, tenkanPeriod, kijunPeriod, senkouBPeriod, senkouShift, chikouShift);
		}

		public TWSTStochastic TWSTStochastic(int period, int stochLength)
		{
			return TWSTStochastic(Input, period, stochLength);
		}

		public TWSTOpeningRange TWSTOpeningRange(TWSTTimeZonesOR openingRangeTZSelector, string s_OpeningRangeStart, string s_OpeningRangeEnd, TWSTPreSessionTypeOR preSessionType, TWSTTimeZonesOR preSessionTZSelector, string s_PreSessionStart, string s_PreSessionEnd)
		{
			return TWSTOpeningRange(Input, openingRangeTZSelector, s_OpeningRangeStart, s_OpeningRangeEnd, preSessionType, preSessionTZSelector, s_PreSessionStart, s_PreSessionEnd);
		}

		public TWSTsuperTrend TWSTsuperTrend(TWSTSuperTrendMode smode, TWSTMovingAverageType maType, int smooth, bool showArrows, bool colorBars, bool playAlert)
		{
			return TWSTsuperTrend(Input, smode, maType, smooth, showArrows, colorBars, playAlert);
		}

		public TWSTfilterLine TWSTfilterLine(int poles, int period)
		{
			return TWSTfilterLine(Input, poles, period);
		}

		public TWSTtrendLiner TWSTtrendLiner(int strength, int numberOfTrendLines, int oldTrendsOpacity, bool alertOnBreak)
		{
			return TWSTtrendLiner(Input, strength, numberOfTrendLines, oldTrendsOpacity, alertOnBreak);
		}

		public TwstEMA TwstEMA(int fast)
		{
			return TwstEMA(Input, fast);
		}

		public TWSTmarketProfile TWSTmarketProfile(int eLineTransparency, int eTextDecimals, int eTextPosition, int eLineHeight, bool inclWeekendVol, TimeSpan openTime, double pctOfVolumeInVA, int presentMethod, int previousSessions, _TWSTdValueEnums.TWSTmarketProfile profileType, int screenMapType, int screenPercent, int screenPosition, double sessionLengthHours, bool showDailyPlots, int showEvolvingPOCs, bool showRtPOC, int slotMinHeight, int slotTransparency, int totalSlots, bool useSessTemplate, int vACalcType, bool zOrderPutBehind)
		{
			return TWSTmarketProfile(Input, eLineTransparency, eTextDecimals, eTextPosition, eLineHeight, inclWeekendVol, openTime, pctOfVolumeInVA, presentMethod, previousSessions, profileType, screenMapType, screenPercent, screenPosition, sessionLengthHours, showDailyPlots, showEvolvingPOCs, showRtPOC, slotMinHeight, slotTransparency, totalSlots, useSessTemplate, vACalcType, zOrderPutBehind);
		}

		public EMASlopeColor EMASlopeColor(int period, Brush upColor, Brush dnColor, bool colorSlope)
		{
			return EMASlopeColor(Input, period, upColor, dnColor, colorSlope);
		}


		
		public TWSTHACO TWSTHACO(ISeries<double> input, int avg, int avgDn, int backgroundOpacity)
		{
			if (cacheTWSTHACO != null)
				for (int idx = 0; idx < cacheTWSTHACO.Length; idx++)
					if (cacheTWSTHACO[idx].Avg == avg && cacheTWSTHACO[idx].AvgDn == avgDn && cacheTWSTHACO[idx].BackgroundOpacity == backgroundOpacity && cacheTWSTHACO[idx].EqualsInput(input))
						return cacheTWSTHACO[idx];
			return CacheIndicator<TWSTHACO>(new TWSTHACO(){ Avg = avg, AvgDn = avgDn, BackgroundOpacity = backgroundOpacity }, input, ref cacheTWSTHACO);
		}

		public TWST123DonchianChannel TWST123DonchianChannel(ISeries<double> input, mamaDonchianInput selectedInput, int period, mamaDonchianTrendMode trendMode, double multiplierFast, double multiplierSlow)
		{
			if (cacheTWST123DonchianChannel != null)
				for (int idx = 0; idx < cacheTWST123DonchianChannel.Length; idx++)
					if (cacheTWST123DonchianChannel[idx].SelectedInput == selectedInput && cacheTWST123DonchianChannel[idx].Period == period && cacheTWST123DonchianChannel[idx].TrendMode == trendMode && cacheTWST123DonchianChannel[idx].MultiplierFast == multiplierFast && cacheTWST123DonchianChannel[idx].MultiplierSlow == multiplierSlow && cacheTWST123DonchianChannel[idx].EqualsInput(input))
						return cacheTWST123DonchianChannel[idx];
			return CacheIndicator<TWST123DonchianChannel>(new TWST123DonchianChannel(){ SelectedInput = selectedInput, Period = period, TrendMode = trendMode, MultiplierFast = multiplierFast, MultiplierSlow = multiplierSlow }, input, ref cacheTWST123DonchianChannel);
		}

		public TWSTFibsFromPriorDay TWSTFibsFromPriorDay(ISeries<double> input, TWSTSessionTypeFPD sessionType, TWSTCalcModeFPD calcMode, double fibRetracementRatio1, double fibRetracementRatio2, double fibRetracementRatio3, double fibRetracementRatio4, double fibRetracementRatio5, double fibExpansionRatio1, double fibExpansionRatio2, double fibExpansionRatio3, double fibExpansionRatio4, double fibExpansionRatio5)
		{
			if (cacheTWSTFibsFromPriorDay != null)
				for (int idx = 0; idx < cacheTWSTFibsFromPriorDay.Length; idx++)
					if (cacheTWSTFibsFromPriorDay[idx].SessionType == sessionType && cacheTWSTFibsFromPriorDay[idx].CalcMode == calcMode && cacheTWSTFibsFromPriorDay[idx].FibRetracementRatio1 == fibRetracementRatio1 && cacheTWSTFibsFromPriorDay[idx].FibRetracementRatio2 == fibRetracementRatio2 && cacheTWSTFibsFromPriorDay[idx].FibRetracementRatio3 == fibRetracementRatio3 && cacheTWSTFibsFromPriorDay[idx].FibRetracementRatio4 == fibRetracementRatio4 && cacheTWSTFibsFromPriorDay[idx].FibRetracementRatio5 == fibRetracementRatio5 && cacheTWSTFibsFromPriorDay[idx].FibExpansionRatio1 == fibExpansionRatio1 && cacheTWSTFibsFromPriorDay[idx].FibExpansionRatio2 == fibExpansionRatio2 && cacheTWSTFibsFromPriorDay[idx].FibExpansionRatio3 == fibExpansionRatio3 && cacheTWSTFibsFromPriorDay[idx].FibExpansionRatio4 == fibExpansionRatio4 && cacheTWSTFibsFromPriorDay[idx].FibExpansionRatio5 == fibExpansionRatio5 && cacheTWSTFibsFromPriorDay[idx].EqualsInput(input))
						return cacheTWSTFibsFromPriorDay[idx];
			return CacheIndicator<TWSTFibsFromPriorDay>(new TWSTFibsFromPriorDay(){ SessionType = sessionType, CalcMode = calcMode, FibRetracementRatio1 = fibRetracementRatio1, FibRetracementRatio2 = fibRetracementRatio2, FibRetracementRatio3 = fibRetracementRatio3, FibRetracementRatio4 = fibRetracementRatio4, FibRetracementRatio5 = fibRetracementRatio5, FibExpansionRatio1 = fibExpansionRatio1, FibExpansionRatio2 = fibExpansionRatio2, FibExpansionRatio3 = fibExpansionRatio3, FibExpansionRatio4 = fibExpansionRatio4, FibExpansionRatio5 = fibExpansionRatio5 }, input, ref cacheTWSTFibsFromPriorDay);
		}

		public TWSTFibsFromCurrentDay TWSTFibsFromCurrentDay(ISeries<double> input, TWSTCalcModeFCD calcMode, double fibRetracementRatio1, double fibRetracementRatio2, double fibRetracementRatio3, double fibRetracementRatio4, double fibRetracementRatio5, double fibRetracementRatio6, double fibRetracementRatio7)
		{
			if (cacheTWSTFibsFromCurrentDay != null)
				for (int idx = 0; idx < cacheTWSTFibsFromCurrentDay.Length; idx++)
					if (cacheTWSTFibsFromCurrentDay[idx].CalcMode == calcMode && cacheTWSTFibsFromCurrentDay[idx].FibRetracementRatio1 == fibRetracementRatio1 && cacheTWSTFibsFromCurrentDay[idx].FibRetracementRatio2 == fibRetracementRatio2 && cacheTWSTFibsFromCurrentDay[idx].FibRetracementRatio3 == fibRetracementRatio3 && cacheTWSTFibsFromCurrentDay[idx].FibRetracementRatio4 == fibRetracementRatio4 && cacheTWSTFibsFromCurrentDay[idx].FibRetracementRatio5 == fibRetracementRatio5 && cacheTWSTFibsFromCurrentDay[idx].FibRetracementRatio6 == fibRetracementRatio6 && cacheTWSTFibsFromCurrentDay[idx].FibRetracementRatio7 == fibRetracementRatio7 && cacheTWSTFibsFromCurrentDay[idx].EqualsInput(input))
						return cacheTWSTFibsFromCurrentDay[idx];
			return CacheIndicator<TWSTFibsFromCurrentDay>(new TWSTFibsFromCurrentDay(){ CalcMode = calcMode, FibRetracementRatio1 = fibRetracementRatio1, FibRetracementRatio2 = fibRetracementRatio2, FibRetracementRatio3 = fibRetracementRatio3, FibRetracementRatio4 = fibRetracementRatio4, FibRetracementRatio5 = fibRetracementRatio5, FibRetracementRatio6 = fibRetracementRatio6, FibRetracementRatio7 = fibRetracementRatio7 }, input, ref cacheTWSTFibsFromCurrentDay);
		}

		public TWST_HighLow_AreaSuperTrend TWST_HighLow_AreaSuperTrend(ISeries<double> input, int tenkanPeriod, int kijunPeriod, int senkouBPeriod, int senkouShift, int chikouShift)
		{
			if (cacheTWST_HighLow_AreaSuperTrend != null)
				for (int idx = 0; idx < cacheTWST_HighLow_AreaSuperTrend.Length; idx++)
					if (cacheTWST_HighLow_AreaSuperTrend[idx].TenkanPeriod == tenkanPeriod && cacheTWST_HighLow_AreaSuperTrend[idx].KijunPeriod == kijunPeriod && cacheTWST_HighLow_AreaSuperTrend[idx].SenkouBPeriod == senkouBPeriod && cacheTWST_HighLow_AreaSuperTrend[idx].SenkouShift == senkouShift && cacheTWST_HighLow_AreaSuperTrend[idx].ChikouShift == chikouShift && cacheTWST_HighLow_AreaSuperTrend[idx].EqualsInput(input))
						return cacheTWST_HighLow_AreaSuperTrend[idx];
			return CacheIndicator<TWST_HighLow_AreaSuperTrend>(new TWST_HighLow_AreaSuperTrend(){ TenkanPeriod = tenkanPeriod, KijunPeriod = kijunPeriod, SenkouBPeriod = senkouBPeriod, SenkouShift = senkouShift, ChikouShift = chikouShift }, input, ref cacheTWST_HighLow_AreaSuperTrend);
		}

		public TWSTStochastic TWSTStochastic(ISeries<double> input, int period, int stochLength)
		{
			if (cacheTWSTStochastic != null)
				for (int idx = 0; idx < cacheTWSTStochastic.Length; idx++)
					if (cacheTWSTStochastic[idx].Period == period && cacheTWSTStochastic[idx].StochLength == stochLength && cacheTWSTStochastic[idx].EqualsInput(input))
						return cacheTWSTStochastic[idx];
			return CacheIndicator<TWSTStochastic>(new TWSTStochastic(){ Period = period, StochLength = stochLength }, input, ref cacheTWSTStochastic);
		}

		public TWSTOpeningRange TWSTOpeningRange(ISeries<double> input, TWSTTimeZonesOR openingRangeTZSelector, string s_OpeningRangeStart, string s_OpeningRangeEnd, TWSTPreSessionTypeOR preSessionType, TWSTTimeZonesOR preSessionTZSelector, string s_PreSessionStart, string s_PreSessionEnd)
		{
			if (cacheTWSTOpeningRange != null)
				for (int idx = 0; idx < cacheTWSTOpeningRange.Length; idx++)
					if (cacheTWSTOpeningRange[idx].OpeningRangeTZSelector == openingRangeTZSelector && cacheTWSTOpeningRange[idx].S_OpeningRangeStart == s_OpeningRangeStart && cacheTWSTOpeningRange[idx].S_OpeningRangeEnd == s_OpeningRangeEnd && cacheTWSTOpeningRange[idx].PreSessionType == preSessionType && cacheTWSTOpeningRange[idx].PreSessionTZSelector == preSessionTZSelector && cacheTWSTOpeningRange[idx].S_PreSessionStart == s_PreSessionStart && cacheTWSTOpeningRange[idx].S_PreSessionEnd == s_PreSessionEnd && cacheTWSTOpeningRange[idx].EqualsInput(input))
						return cacheTWSTOpeningRange[idx];
			return CacheIndicator<TWSTOpeningRange>(new TWSTOpeningRange(){ OpeningRangeTZSelector = openingRangeTZSelector, S_OpeningRangeStart = s_OpeningRangeStart, S_OpeningRangeEnd = s_OpeningRangeEnd, PreSessionType = preSessionType, PreSessionTZSelector = preSessionTZSelector, S_PreSessionStart = s_PreSessionStart, S_PreSessionEnd = s_PreSessionEnd }, input, ref cacheTWSTOpeningRange);
		}

		public TWSTsuperTrend TWSTsuperTrend(ISeries<double> input, TWSTSuperTrendMode smode, TWSTMovingAverageType maType, int smooth, bool showArrows, bool colorBars, bool playAlert)
		{
			if (cacheTWSTsuperTrend != null)
				for (int idx = 0; idx < cacheTWSTsuperTrend.Length; idx++)
					if (cacheTWSTsuperTrend[idx].Smode == smode && cacheTWSTsuperTrend[idx].MaType == maType && cacheTWSTsuperTrend[idx].Smooth == smooth && cacheTWSTsuperTrend[idx].ShowArrows == showArrows && cacheTWSTsuperTrend[idx].ColorBars == colorBars && cacheTWSTsuperTrend[idx].PlayAlert == playAlert && cacheTWSTsuperTrend[idx].EqualsInput(input))
						return cacheTWSTsuperTrend[idx];
			return CacheIndicator<TWSTsuperTrend>(new TWSTsuperTrend(){ Smode = smode, MaType = maType, Smooth = smooth, ShowArrows = showArrows, ColorBars = colorBars, PlayAlert = playAlert }, input, ref cacheTWSTsuperTrend);
		}

		public TWSTfilterLine TWSTfilterLine(ISeries<double> input, int poles, int period)
		{
			if (cacheTWSTfilterLine != null)
				for (int idx = 0; idx < cacheTWSTfilterLine.Length; idx++)
					if (cacheTWSTfilterLine[idx].Poles == poles && cacheTWSTfilterLine[idx].Period == period && cacheTWSTfilterLine[idx].EqualsInput(input))
						return cacheTWSTfilterLine[idx];
			return CacheIndicator<TWSTfilterLine>(new TWSTfilterLine(){ Poles = poles, Period = period }, input, ref cacheTWSTfilterLine);
		}

		public TWSTtrendLiner TWSTtrendLiner(ISeries<double> input, int strength, int numberOfTrendLines, int oldTrendsOpacity, bool alertOnBreak)
		{
			if (cacheTWSTtrendLiner != null)
				for (int idx = 0; idx < cacheTWSTtrendLiner.Length; idx++)
					if (cacheTWSTtrendLiner[idx].Strength == strength && cacheTWSTtrendLiner[idx].NumberOfTrendLines == numberOfTrendLines && cacheTWSTtrendLiner[idx].OldTrendsOpacity == oldTrendsOpacity && cacheTWSTtrendLiner[idx].AlertOnBreak == alertOnBreak && cacheTWSTtrendLiner[idx].EqualsInput(input))
						return cacheTWSTtrendLiner[idx];
			return CacheIndicator<TWSTtrendLiner>(new TWSTtrendLiner(){ Strength = strength, NumberOfTrendLines = numberOfTrendLines, OldTrendsOpacity = oldTrendsOpacity, AlertOnBreak = alertOnBreak }, input, ref cacheTWSTtrendLiner);
		}

		public TwstEMA TwstEMA(ISeries<double> input, int fast)
		{
			if (cacheTwstEMA != null)
				for (int idx = 0; idx < cacheTwstEMA.Length; idx++)
					if (cacheTwstEMA[idx].Fast == fast && cacheTwstEMA[idx].EqualsInput(input))
						return cacheTwstEMA[idx];
			return CacheIndicator<TwstEMA>(new TwstEMA(){ Fast = fast }, input, ref cacheTwstEMA);
		}

		public TWSTmarketProfile TWSTmarketProfile(ISeries<double> input, int eLineTransparency, int eTextDecimals, int eTextPosition, int eLineHeight, bool inclWeekendVol, TimeSpan openTime, double pctOfVolumeInVA, int presentMethod, int previousSessions, _TWSTdValueEnums.TWSTmarketProfile profileType, int screenMapType, int screenPercent, int screenPosition, double sessionLengthHours, bool showDailyPlots, int showEvolvingPOCs, bool showRtPOC, int slotMinHeight, int slotTransparency, int totalSlots, bool useSessTemplate, int vACalcType, bool zOrderPutBehind)
		{
			if (cacheTWSTmarketProfile != null)
				for (int idx = 0; idx < cacheTWSTmarketProfile.Length; idx++)
					if (cacheTWSTmarketProfile[idx].ELineTransparency == eLineTransparency && cacheTWSTmarketProfile[idx].ETextDecimals == eTextDecimals && cacheTWSTmarketProfile[idx].ETextPosition == eTextPosition && cacheTWSTmarketProfile[idx].ELineHeight == eLineHeight && cacheTWSTmarketProfile[idx].InclWeekendVol == inclWeekendVol && cacheTWSTmarketProfile[idx].OpenTime == openTime && cacheTWSTmarketProfile[idx].PctOfVolumeInVA == pctOfVolumeInVA && cacheTWSTmarketProfile[idx].PresentMethod == presentMethod && cacheTWSTmarketProfile[idx].PreviousSessions == previousSessions && cacheTWSTmarketProfile[idx].ProfileType == profileType && cacheTWSTmarketProfile[idx].ScreenMapType == screenMapType && cacheTWSTmarketProfile[idx].ScreenPercent == screenPercent && cacheTWSTmarketProfile[idx].ScreenPosition == screenPosition && cacheTWSTmarketProfile[idx].SessionLengthHours == sessionLengthHours && cacheTWSTmarketProfile[idx].ShowDailyPlots == showDailyPlots && cacheTWSTmarketProfile[idx].ShowEvolvingPOCs == showEvolvingPOCs && cacheTWSTmarketProfile[idx].ShowRtPOC == showRtPOC && cacheTWSTmarketProfile[idx].SlotMinHeight == slotMinHeight && cacheTWSTmarketProfile[idx].SlotTransparency == slotTransparency && cacheTWSTmarketProfile[idx].TotalSlots == totalSlots && cacheTWSTmarketProfile[idx].UseSessTemplate == useSessTemplate && cacheTWSTmarketProfile[idx].VACalcType == vACalcType && cacheTWSTmarketProfile[idx].ZOrderPutBehind == zOrderPutBehind && cacheTWSTmarketProfile[idx].EqualsInput(input))
						return cacheTWSTmarketProfile[idx];
			return CacheIndicator<TWSTmarketProfile>(new TWSTmarketProfile(){ ELineTransparency = eLineTransparency, ETextDecimals = eTextDecimals, ETextPosition = eTextPosition, ELineHeight = eLineHeight, InclWeekendVol = inclWeekendVol, OpenTime = openTime, PctOfVolumeInVA = pctOfVolumeInVA, PresentMethod = presentMethod, PreviousSessions = previousSessions, ProfileType = profileType, ScreenMapType = screenMapType, ScreenPercent = screenPercent, ScreenPosition = screenPosition, SessionLengthHours = sessionLengthHours, ShowDailyPlots = showDailyPlots, ShowEvolvingPOCs = showEvolvingPOCs, ShowRtPOC = showRtPOC, SlotMinHeight = slotMinHeight, SlotTransparency = slotTransparency, TotalSlots = totalSlots, UseSessTemplate = useSessTemplate, VACalcType = vACalcType, ZOrderPutBehind = zOrderPutBehind }, input, ref cacheTWSTmarketProfile);
		}

		public EMASlopeColor EMASlopeColor(ISeries<double> input, int period, Brush upColor, Brush dnColor, bool colorSlope)
		{
			if (cacheEMASlopeColor != null)
				for (int idx = 0; idx < cacheEMASlopeColor.Length; idx++)
					if (cacheEMASlopeColor[idx].Period == period && cacheEMASlopeColor[idx].UpColor == upColor && cacheEMASlopeColor[idx].DnColor == dnColor && cacheEMASlopeColor[idx].ColorSlope == colorSlope && cacheEMASlopeColor[idx].EqualsInput(input))
						return cacheEMASlopeColor[idx];
			return CacheIndicator<EMASlopeColor>(new EMASlopeColor(){ Period = period, UpColor = upColor, DnColor = dnColor, ColorSlope = colorSlope }, input, ref cacheEMASlopeColor);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.TWSTHACO TWSTHACO(int avg, int avgDn, int backgroundOpacity)
		{
			return indicator.TWSTHACO(Input, avg, avgDn, backgroundOpacity);
		}

		public Indicators.TWST123DonchianChannel TWST123DonchianChannel(mamaDonchianInput selectedInput, int period, mamaDonchianTrendMode trendMode, double multiplierFast, double multiplierSlow)
		{
			return indicator.TWST123DonchianChannel(Input, selectedInput, period, trendMode, multiplierFast, multiplierSlow);
		}

		public Indicators.TWSTFibsFromPriorDay TWSTFibsFromPriorDay(TWSTSessionTypeFPD sessionType, TWSTCalcModeFPD calcMode, double fibRetracementRatio1, double fibRetracementRatio2, double fibRetracementRatio3, double fibRetracementRatio4, double fibRetracementRatio5, double fibExpansionRatio1, double fibExpansionRatio2, double fibExpansionRatio3, double fibExpansionRatio4, double fibExpansionRatio5)
		{
			return indicator.TWSTFibsFromPriorDay(Input, sessionType, calcMode, fibRetracementRatio1, fibRetracementRatio2, fibRetracementRatio3, fibRetracementRatio4, fibRetracementRatio5, fibExpansionRatio1, fibExpansionRatio2, fibExpansionRatio3, fibExpansionRatio4, fibExpansionRatio5);
		}

		public Indicators.TWSTFibsFromCurrentDay TWSTFibsFromCurrentDay(TWSTCalcModeFCD calcMode, double fibRetracementRatio1, double fibRetracementRatio2, double fibRetracementRatio3, double fibRetracementRatio4, double fibRetracementRatio5, double fibRetracementRatio6, double fibRetracementRatio7)
		{
			return indicator.TWSTFibsFromCurrentDay(Input, calcMode, fibRetracementRatio1, fibRetracementRatio2, fibRetracementRatio3, fibRetracementRatio4, fibRetracementRatio5, fibRetracementRatio6, fibRetracementRatio7);
		}

		public Indicators.TWST_HighLow_AreaSuperTrend TWST_HighLow_AreaSuperTrend(int tenkanPeriod, int kijunPeriod, int senkouBPeriod, int senkouShift, int chikouShift)
		{
			return indicator.TWST_HighLow_AreaSuperTrend(Input, tenkanPeriod, kijunPeriod, senkouBPeriod, senkouShift, chikouShift);
		}

		public Indicators.TWSTStochastic TWSTStochastic(int period, int stochLength)
		{
			return indicator.TWSTStochastic(Input, period, stochLength);
		}

		public Indicators.TWSTOpeningRange TWSTOpeningRange(TWSTTimeZonesOR openingRangeTZSelector, string s_OpeningRangeStart, string s_OpeningRangeEnd, TWSTPreSessionTypeOR preSessionType, TWSTTimeZonesOR preSessionTZSelector, string s_PreSessionStart, string s_PreSessionEnd)
		{
			return indicator.TWSTOpeningRange(Input, openingRangeTZSelector, s_OpeningRangeStart, s_OpeningRangeEnd, preSessionType, preSessionTZSelector, s_PreSessionStart, s_PreSessionEnd);
		}

		public Indicators.TWSTsuperTrend TWSTsuperTrend(TWSTSuperTrendMode smode, TWSTMovingAverageType maType, int smooth, bool showArrows, bool colorBars, bool playAlert)
		{
			return indicator.TWSTsuperTrend(Input, smode, maType, smooth, showArrows, colorBars, playAlert);
		}

		public Indicators.TWSTfilterLine TWSTfilterLine(int poles, int period)
		{
			return indicator.TWSTfilterLine(Input, poles, period);
		}

		public Indicators.TWSTtrendLiner TWSTtrendLiner(int strength, int numberOfTrendLines, int oldTrendsOpacity, bool alertOnBreak)
		{
			return indicator.TWSTtrendLiner(Input, strength, numberOfTrendLines, oldTrendsOpacity, alertOnBreak);
		}

		public Indicators.TwstEMA TwstEMA(int fast)
		{
			return indicator.TwstEMA(Input, fast);
		}

		public Indicators.TWSTmarketProfile TWSTmarketProfile(int eLineTransparency, int eTextDecimals, int eTextPosition, int eLineHeight, bool inclWeekendVol, TimeSpan openTime, double pctOfVolumeInVA, int presentMethod, int previousSessions, _TWSTdValueEnums.TWSTmarketProfile profileType, int screenMapType, int screenPercent, int screenPosition, double sessionLengthHours, bool showDailyPlots, int showEvolvingPOCs, bool showRtPOC, int slotMinHeight, int slotTransparency, int totalSlots, bool useSessTemplate, int vACalcType, bool zOrderPutBehind)
		{
			return indicator.TWSTmarketProfile(Input, eLineTransparency, eTextDecimals, eTextPosition, eLineHeight, inclWeekendVol, openTime, pctOfVolumeInVA, presentMethod, previousSessions, profileType, screenMapType, screenPercent, screenPosition, sessionLengthHours, showDailyPlots, showEvolvingPOCs, showRtPOC, slotMinHeight, slotTransparency, totalSlots, useSessTemplate, vACalcType, zOrderPutBehind);
		}

		public Indicators.EMASlopeColor EMASlopeColor(int period, Brush upColor, Brush dnColor, bool colorSlope)
		{
			return indicator.EMASlopeColor(Input, period, upColor, dnColor, colorSlope);
		}


		
		public Indicators.TWSTHACO TWSTHACO(ISeries<double> input , int avg, int avgDn, int backgroundOpacity)
		{
			return indicator.TWSTHACO(input, avg, avgDn, backgroundOpacity);
		}

		public Indicators.TWST123DonchianChannel TWST123DonchianChannel(ISeries<double> input , mamaDonchianInput selectedInput, int period, mamaDonchianTrendMode trendMode, double multiplierFast, double multiplierSlow)
		{
			return indicator.TWST123DonchianChannel(input, selectedInput, period, trendMode, multiplierFast, multiplierSlow);
		}

		public Indicators.TWSTFibsFromPriorDay TWSTFibsFromPriorDay(ISeries<double> input , TWSTSessionTypeFPD sessionType, TWSTCalcModeFPD calcMode, double fibRetracementRatio1, double fibRetracementRatio2, double fibRetracementRatio3, double fibRetracementRatio4, double fibRetracementRatio5, double fibExpansionRatio1, double fibExpansionRatio2, double fibExpansionRatio3, double fibExpansionRatio4, double fibExpansionRatio5)
		{
			return indicator.TWSTFibsFromPriorDay(input, sessionType, calcMode, fibRetracementRatio1, fibRetracementRatio2, fibRetracementRatio3, fibRetracementRatio4, fibRetracementRatio5, fibExpansionRatio1, fibExpansionRatio2, fibExpansionRatio3, fibExpansionRatio4, fibExpansionRatio5);
		}

		public Indicators.TWSTFibsFromCurrentDay TWSTFibsFromCurrentDay(ISeries<double> input , TWSTCalcModeFCD calcMode, double fibRetracementRatio1, double fibRetracementRatio2, double fibRetracementRatio3, double fibRetracementRatio4, double fibRetracementRatio5, double fibRetracementRatio6, double fibRetracementRatio7)
		{
			return indicator.TWSTFibsFromCurrentDay(input, calcMode, fibRetracementRatio1, fibRetracementRatio2, fibRetracementRatio3, fibRetracementRatio4, fibRetracementRatio5, fibRetracementRatio6, fibRetracementRatio7);
		}

		public Indicators.TWST_HighLow_AreaSuperTrend TWST_HighLow_AreaSuperTrend(ISeries<double> input , int tenkanPeriod, int kijunPeriod, int senkouBPeriod, int senkouShift, int chikouShift)
		{
			return indicator.TWST_HighLow_AreaSuperTrend(input, tenkanPeriod, kijunPeriod, senkouBPeriod, senkouShift, chikouShift);
		}

		public Indicators.TWSTStochastic TWSTStochastic(ISeries<double> input , int period, int stochLength)
		{
			return indicator.TWSTStochastic(input, period, stochLength);
		}

		public Indicators.TWSTOpeningRange TWSTOpeningRange(ISeries<double> input , TWSTTimeZonesOR openingRangeTZSelector, string s_OpeningRangeStart, string s_OpeningRangeEnd, TWSTPreSessionTypeOR preSessionType, TWSTTimeZonesOR preSessionTZSelector, string s_PreSessionStart, string s_PreSessionEnd)
		{
			return indicator.TWSTOpeningRange(input, openingRangeTZSelector, s_OpeningRangeStart, s_OpeningRangeEnd, preSessionType, preSessionTZSelector, s_PreSessionStart, s_PreSessionEnd);
		}

		public Indicators.TWSTsuperTrend TWSTsuperTrend(ISeries<double> input , TWSTSuperTrendMode smode, TWSTMovingAverageType maType, int smooth, bool showArrows, bool colorBars, bool playAlert)
		{
			return indicator.TWSTsuperTrend(input, smode, maType, smooth, showArrows, colorBars, playAlert);
		}

		public Indicators.TWSTfilterLine TWSTfilterLine(ISeries<double> input , int poles, int period)
		{
			return indicator.TWSTfilterLine(input, poles, period);
		}

		public Indicators.TWSTtrendLiner TWSTtrendLiner(ISeries<double> input , int strength, int numberOfTrendLines, int oldTrendsOpacity, bool alertOnBreak)
		{
			return indicator.TWSTtrendLiner(input, strength, numberOfTrendLines, oldTrendsOpacity, alertOnBreak);
		}

		public Indicators.TwstEMA TwstEMA(ISeries<double> input , int fast)
		{
			return indicator.TwstEMA(input, fast);
		}

		public Indicators.TWSTmarketProfile TWSTmarketProfile(ISeries<double> input , int eLineTransparency, int eTextDecimals, int eTextPosition, int eLineHeight, bool inclWeekendVol, TimeSpan openTime, double pctOfVolumeInVA, int presentMethod, int previousSessions, _TWSTdValueEnums.TWSTmarketProfile profileType, int screenMapType, int screenPercent, int screenPosition, double sessionLengthHours, bool showDailyPlots, int showEvolvingPOCs, bool showRtPOC, int slotMinHeight, int slotTransparency, int totalSlots, bool useSessTemplate, int vACalcType, bool zOrderPutBehind)
		{
			return indicator.TWSTmarketProfile(input, eLineTransparency, eTextDecimals, eTextPosition, eLineHeight, inclWeekendVol, openTime, pctOfVolumeInVA, presentMethod, previousSessions, profileType, screenMapType, screenPercent, screenPosition, sessionLengthHours, showDailyPlots, showEvolvingPOCs, showRtPOC, slotMinHeight, slotTransparency, totalSlots, useSessTemplate, vACalcType, zOrderPutBehind);
		}

		public Indicators.EMASlopeColor EMASlopeColor(ISeries<double> input , int period, Brush upColor, Brush dnColor, bool colorSlope)
		{
			return indicator.EMASlopeColor(input, period, upColor, dnColor, colorSlope);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.TWSTHACO TWSTHACO(int avg, int avgDn, int backgroundOpacity)
		{
			return indicator.TWSTHACO(Input, avg, avgDn, backgroundOpacity);
		}

		public Indicators.TWST123DonchianChannel TWST123DonchianChannel(mamaDonchianInput selectedInput, int period, mamaDonchianTrendMode trendMode, double multiplierFast, double multiplierSlow)
		{
			return indicator.TWST123DonchianChannel(Input, selectedInput, period, trendMode, multiplierFast, multiplierSlow);
		}

		public Indicators.TWSTFibsFromPriorDay TWSTFibsFromPriorDay(TWSTSessionTypeFPD sessionType, TWSTCalcModeFPD calcMode, double fibRetracementRatio1, double fibRetracementRatio2, double fibRetracementRatio3, double fibRetracementRatio4, double fibRetracementRatio5, double fibExpansionRatio1, double fibExpansionRatio2, double fibExpansionRatio3, double fibExpansionRatio4, double fibExpansionRatio5)
		{
			return indicator.TWSTFibsFromPriorDay(Input, sessionType, calcMode, fibRetracementRatio1, fibRetracementRatio2, fibRetracementRatio3, fibRetracementRatio4, fibRetracementRatio5, fibExpansionRatio1, fibExpansionRatio2, fibExpansionRatio3, fibExpansionRatio4, fibExpansionRatio5);
		}

		public Indicators.TWSTFibsFromCurrentDay TWSTFibsFromCurrentDay(TWSTCalcModeFCD calcMode, double fibRetracementRatio1, double fibRetracementRatio2, double fibRetracementRatio3, double fibRetracementRatio4, double fibRetracementRatio5, double fibRetracementRatio6, double fibRetracementRatio7)
		{
			return indicator.TWSTFibsFromCurrentDay(Input, calcMode, fibRetracementRatio1, fibRetracementRatio2, fibRetracementRatio3, fibRetracementRatio4, fibRetracementRatio5, fibRetracementRatio6, fibRetracementRatio7);
		}

		public Indicators.TWST_HighLow_AreaSuperTrend TWST_HighLow_AreaSuperTrend(int tenkanPeriod, int kijunPeriod, int senkouBPeriod, int senkouShift, int chikouShift)
		{
			return indicator.TWST_HighLow_AreaSuperTrend(Input, tenkanPeriod, kijunPeriod, senkouBPeriod, senkouShift, chikouShift);
		}

		public Indicators.TWSTStochastic TWSTStochastic(int period, int stochLength)
		{
			return indicator.TWSTStochastic(Input, period, stochLength);
		}

		public Indicators.TWSTOpeningRange TWSTOpeningRange(TWSTTimeZonesOR openingRangeTZSelector, string s_OpeningRangeStart, string s_OpeningRangeEnd, TWSTPreSessionTypeOR preSessionType, TWSTTimeZonesOR preSessionTZSelector, string s_PreSessionStart, string s_PreSessionEnd)
		{
			return indicator.TWSTOpeningRange(Input, openingRangeTZSelector, s_OpeningRangeStart, s_OpeningRangeEnd, preSessionType, preSessionTZSelector, s_PreSessionStart, s_PreSessionEnd);
		}

		public Indicators.TWSTsuperTrend TWSTsuperTrend(TWSTSuperTrendMode smode, TWSTMovingAverageType maType, int smooth, bool showArrows, bool colorBars, bool playAlert)
		{
			return indicator.TWSTsuperTrend(Input, smode, maType, smooth, showArrows, colorBars, playAlert);
		}

		public Indicators.TWSTfilterLine TWSTfilterLine(int poles, int period)
		{
			return indicator.TWSTfilterLine(Input, poles, period);
		}

		public Indicators.TWSTtrendLiner TWSTtrendLiner(int strength, int numberOfTrendLines, int oldTrendsOpacity, bool alertOnBreak)
		{
			return indicator.TWSTtrendLiner(Input, strength, numberOfTrendLines, oldTrendsOpacity, alertOnBreak);
		}

		public Indicators.TwstEMA TwstEMA(int fast)
		{
			return indicator.TwstEMA(Input, fast);
		}

		public Indicators.TWSTmarketProfile TWSTmarketProfile(int eLineTransparency, int eTextDecimals, int eTextPosition, int eLineHeight, bool inclWeekendVol, TimeSpan openTime, double pctOfVolumeInVA, int presentMethod, int previousSessions, _TWSTdValueEnums.TWSTmarketProfile profileType, int screenMapType, int screenPercent, int screenPosition, double sessionLengthHours, bool showDailyPlots, int showEvolvingPOCs, bool showRtPOC, int slotMinHeight, int slotTransparency, int totalSlots, bool useSessTemplate, int vACalcType, bool zOrderPutBehind)
		{
			return indicator.TWSTmarketProfile(Input, eLineTransparency, eTextDecimals, eTextPosition, eLineHeight, inclWeekendVol, openTime, pctOfVolumeInVA, presentMethod, previousSessions, profileType, screenMapType, screenPercent, screenPosition, sessionLengthHours, showDailyPlots, showEvolvingPOCs, showRtPOC, slotMinHeight, slotTransparency, totalSlots, useSessTemplate, vACalcType, zOrderPutBehind);
		}

		public Indicators.EMASlopeColor EMASlopeColor(int period, Brush upColor, Brush dnColor, bool colorSlope)
		{
			return indicator.EMASlopeColor(Input, period, upColor, dnColor, colorSlope);
		}


		
		public Indicators.TWSTHACO TWSTHACO(ISeries<double> input , int avg, int avgDn, int backgroundOpacity)
		{
			return indicator.TWSTHACO(input, avg, avgDn, backgroundOpacity);
		}

		public Indicators.TWST123DonchianChannel TWST123DonchianChannel(ISeries<double> input , mamaDonchianInput selectedInput, int period, mamaDonchianTrendMode trendMode, double multiplierFast, double multiplierSlow)
		{
			return indicator.TWST123DonchianChannel(input, selectedInput, period, trendMode, multiplierFast, multiplierSlow);
		}

		public Indicators.TWSTFibsFromPriorDay TWSTFibsFromPriorDay(ISeries<double> input , TWSTSessionTypeFPD sessionType, TWSTCalcModeFPD calcMode, double fibRetracementRatio1, double fibRetracementRatio2, double fibRetracementRatio3, double fibRetracementRatio4, double fibRetracementRatio5, double fibExpansionRatio1, double fibExpansionRatio2, double fibExpansionRatio3, double fibExpansionRatio4, double fibExpansionRatio5)
		{
			return indicator.TWSTFibsFromPriorDay(input, sessionType, calcMode, fibRetracementRatio1, fibRetracementRatio2, fibRetracementRatio3, fibRetracementRatio4, fibRetracementRatio5, fibExpansionRatio1, fibExpansionRatio2, fibExpansionRatio3, fibExpansionRatio4, fibExpansionRatio5);
		}

		public Indicators.TWSTFibsFromCurrentDay TWSTFibsFromCurrentDay(ISeries<double> input , TWSTCalcModeFCD calcMode, double fibRetracementRatio1, double fibRetracementRatio2, double fibRetracementRatio3, double fibRetracementRatio4, double fibRetracementRatio5, double fibRetracementRatio6, double fibRetracementRatio7)
		{
			return indicator.TWSTFibsFromCurrentDay(input, calcMode, fibRetracementRatio1, fibRetracementRatio2, fibRetracementRatio3, fibRetracementRatio4, fibRetracementRatio5, fibRetracementRatio6, fibRetracementRatio7);
		}

		public Indicators.TWST_HighLow_AreaSuperTrend TWST_HighLow_AreaSuperTrend(ISeries<double> input , int tenkanPeriod, int kijunPeriod, int senkouBPeriod, int senkouShift, int chikouShift)
		{
			return indicator.TWST_HighLow_AreaSuperTrend(input, tenkanPeriod, kijunPeriod, senkouBPeriod, senkouShift, chikouShift);
		}

		public Indicators.TWSTStochastic TWSTStochastic(ISeries<double> input , int period, int stochLength)
		{
			return indicator.TWSTStochastic(input, period, stochLength);
		}

		public Indicators.TWSTOpeningRange TWSTOpeningRange(ISeries<double> input , TWSTTimeZonesOR openingRangeTZSelector, string s_OpeningRangeStart, string s_OpeningRangeEnd, TWSTPreSessionTypeOR preSessionType, TWSTTimeZonesOR preSessionTZSelector, string s_PreSessionStart, string s_PreSessionEnd)
		{
			return indicator.TWSTOpeningRange(input, openingRangeTZSelector, s_OpeningRangeStart, s_OpeningRangeEnd, preSessionType, preSessionTZSelector, s_PreSessionStart, s_PreSessionEnd);
		}

		public Indicators.TWSTsuperTrend TWSTsuperTrend(ISeries<double> input , TWSTSuperTrendMode smode, TWSTMovingAverageType maType, int smooth, bool showArrows, bool colorBars, bool playAlert)
		{
			return indicator.TWSTsuperTrend(input, smode, maType, smooth, showArrows, colorBars, playAlert);
		}

		public Indicators.TWSTfilterLine TWSTfilterLine(ISeries<double> input , int poles, int period)
		{
			return indicator.TWSTfilterLine(input, poles, period);
		}

		public Indicators.TWSTtrendLiner TWSTtrendLiner(ISeries<double> input , int strength, int numberOfTrendLines, int oldTrendsOpacity, bool alertOnBreak)
		{
			return indicator.TWSTtrendLiner(input, strength, numberOfTrendLines, oldTrendsOpacity, alertOnBreak);
		}

		public Indicators.TwstEMA TwstEMA(ISeries<double> input , int fast)
		{
			return indicator.TwstEMA(input, fast);
		}

		public Indicators.TWSTmarketProfile TWSTmarketProfile(ISeries<double> input , int eLineTransparency, int eTextDecimals, int eTextPosition, int eLineHeight, bool inclWeekendVol, TimeSpan openTime, double pctOfVolumeInVA, int presentMethod, int previousSessions, _TWSTdValueEnums.TWSTmarketProfile profileType, int screenMapType, int screenPercent, int screenPosition, double sessionLengthHours, bool showDailyPlots, int showEvolvingPOCs, bool showRtPOC, int slotMinHeight, int slotTransparency, int totalSlots, bool useSessTemplate, int vACalcType, bool zOrderPutBehind)
		{
			return indicator.TWSTmarketProfile(input, eLineTransparency, eTextDecimals, eTextPosition, eLineHeight, inclWeekendVol, openTime, pctOfVolumeInVA, presentMethod, previousSessions, profileType, screenMapType, screenPercent, screenPosition, sessionLengthHours, showDailyPlots, showEvolvingPOCs, showRtPOC, slotMinHeight, slotTransparency, totalSlots, useSessTemplate, vACalcType, zOrderPutBehind);
		}

		public Indicators.EMASlopeColor EMASlopeColor(ISeries<double> input , int period, Brush upColor, Brush dnColor, bool colorSlope)
		{
			return indicator.EMASlopeColor(input, period, upColor, dnColor, colorSlope);
		}

	}
}

#endregion
